package com.tistory.antop.locale.interceptor;

import java.util.HashSet;
import java.util.Locale;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.ui.ModelMap;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

public class RegionInterceptor extends HandlerInterceptorAdapter {

	public final String KEY = "regions";

	private boolean lowerCase = true;

	@Override
	public void postHandle(HttpServletRequest request, HttpServletResponse response,
		Object handler, ModelAndView mav) throws Exception {

		Set<Region> regions = new HashSet<Region>();

		for (Locale locale : Locale.getAvailableLocales()) {
			if (locale.getCountry().isEmpty() == false) {
				String country = locale.getCountry();
				if (lowerCase == true) {
					country = country.toLowerCase();
				}
				String display = locale.getDisplayCountry(locale);

				Region region = new Region(country, display);
				regions.add(region);
			}
		}

		ModelMap mm = mav.getModelMap();

		if (mm.containsKey(KEY) == true) {
			mm.remove(KEY);
		}

		mav.addObject(KEY, regions);
	}

	public void setLowerCase(boolean lowerCase) {
		this.lowerCase = lowerCase;
	}

}
